<?php
// $Id: node_menu_views.inc,v 1.1 2008/03/25 23:13:28 develCuy Exp $

/**
 * Implementation of hook_views_tables().
 */
function node_menu_views_tables() {
  $t = 't';
  $tables['node_menu'] = array(
    'name' => 'node_menu',
    'join' => array(
      'left' => array(
        'table' => 'node',
        'field' => 'nid',
      ),
      'right' => array(
        'field' => 'nm_node_id',
      ),
    ),
  );
  $tables['menu'] = array(
    'name' => 'menu',
    'join' => array(
      'left' => array(
        'table' => 'node_menu',
        'field' => 'nm_menu_id',
      ),
      'right' => array(
        'field' => 'mid',
      ),
    ),
    'fields' => array(
      'path' => array(
        'name' => $t('Node menu: Node title + Menu link'),
        'handler' => array(
          'node_media_handler_field_link' => t('Normal'),
        ),
        'option' => array(
           '#type' => 'select',
           '#options' => array(
             'link' => 'As link',
             'nolink' => 'Without link'
            ),
        ),
        'sortable' => true,
        'help' => $t('Display node title linked to its menu url.'),
      ),
    ),
  );
  
  return $tables;
}

/**
 * 
 */
function node_media_handler_field_link($fieldinfo, $fielddata, $value, $data) {
  $args = func_get_args();
  
  if ($fielddata['options'] == 'nolink') {
    return check_plain($data->node_title);
  }
  
  $query = NULL;
  if ($value) {
    $parsed_url = parse_url($value);
    if ($parsed_url['query'] && !$parsed_url['host']){
      $path = $parsed_url['path'];
      $query = $parsed_url['query'];
    } else {
      $path = $value;
    }
  } else {
    $path = "node/$data->nid";
  }
  
  return l($data->node_title, $path, NULL, $query);
}
